/*
 * Copyright 2004-2006 Robbie.JP
 */
package robbie.dao.x;

import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Properties;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.jdom.Element;

import robbie.dao.DbConnectionUtil;
import robbie.util.CollectionsUtil;

/**
 * XDbResourceFactoryNX.<p>
 */
public class XDbResourceFactory {

    private static final Log LOG = LogFactory.getLog(XDbResourceFactory.class);
    
    /** DbResourcẽCX^XێMap */
    protected Map resourceMap = null;
    
    /**
     * ftHgRXgN^B<p>
     */
    public XDbResourceFactory() {
        // Ȃ
    }
    
    /**
     * w肵IDDbResourcẽCX^XԂ܂B<p>
     * @param id DbResourcew肷ID
     * @return DbResourcẽCX^X
     */
    public XDbResource getDbResource(String id) {
        return (XDbResource)resourceMap.get(id);
    }
    
    /**
     * ݒt@CDbResourcẽCX^X쐬ێ܂B<p>
     * @param resourceListElement Resource`ȂElement
     */
    public void configure(Element resourceListElement) {
        
        List list = resourceListElement.getChildren("resource");
        if (list != null && list.size() > 0) {
            Map map = CollectionsUtil.createMap();
            for (Iterator it=list.iterator(); it.hasNext(); ) {
                Element ele = (Element)it.next();
                String id = ele.getAttributeValue("id");
                if (id == null || id.length() == 0) {
                    throw new XDaoException("Attribute 'id' is null or string.length = 0!");
                }
                String type = ele.getAttributeValue("type");
                if (map.containsKey(id)  && LOG.isDebugEnabled()) {
                    LOG.debug("Warn! id=[" + id + "] definition is over-ride!");
                }
                map.put(id, createXDbResource(type, ele));
            }
            this.resourceMap = map;
            
            if (LOG.isDebugEnabled()) {
                LOG.debug("XDbReource " + this.resourceMap);
            }
            
        } else {
            throw new XDaoException("Element 'resource' is null or empty!");
        }
    }
    
    /**
     * resoucevfDbResourcẽCX^X쐬܂B<p>
     * {IɂXDbResourceFactory͊g̕Kv͂܂񂪁AƎ̕@
     * Connection擾Kvꍇɂ́Ã\bhgĂB
     * @param type Connection̎擾@TYPE
     * @param ele resoucevfElement
     * @return XDbResourceCX^X
     */
    protected XDbResource createXDbResource(String type, Element ele) {
        
        XDbResource resource = null;
        if ("DataSource".equals(type)) {
            
            // Server JDBCiDataSourcejpXML\[XǗ
            String jndiName =null;
            try {
                jndiName = ele.getChild("jndi-name").getText();
                if (jndiName == null || jndiName.length() == 0) {
                    throw new XDaoException("Element 'jndi-name' is null or string.length = 0!");
                }
            } catch(Exception ex) {
                throw new XDaoException("Element 'jndi-name' is null!");
            }
            resource =  new DataSourceResource(jndiName);
            
        } else if ("JDBC".equals(type)) {
            
            // Local JDBCpXML\[XǗ
            Properties env = null;
            try {
                env = DbConnectionUtil.createConnectionProperties(
                        ele.getChild("driver").getText(),
                        ele.getChild("url").getText(),
                        ele.getChild("username").getText(),
                        ele.getChild("password").getText());
            } catch(Exception ex) {
                throw new XDaoException("Element 'driver' or 'url' or 'username' or 'password' is null!");
            }
            resource = new JdbcResource(env);
            
        } else if ("JDBC-ODBC".equals(type)) {
            
            // JDBC-ODBCpXML\[XǗ
            String sourceName = null;
            try {
                sourceName = ele.getChild("odbc-data-source").getText();
                if (sourceName == null || sourceName.length() == 0) {
                    throw new XDaoException("Element 'odbc-data-source' is null or string.length = 0!");
                }
            } catch(Exception ex) {
                throw new XDaoException("Element 'odbc-data-source' is null!");
            }
            resource = new JdbcOdbcResource(sourceName);
            
        } else {
            throw new XDaoException("Resource type not mattched. type=" + type);
        }
        return resource;
    }
}
